﻿@model AuthnData.Models.Sondage.AddSondageViewModel
@{
    var error = TempData["Error"] as string;
    ViewData["Title"] = "Créer un Sondage";
}
@if(!string.IsNullOrEmpty(error))
{
     <h2 class="alert-danger" style="padding:20px;">@error</h2>
}
@section Scripts
{
    <link rel="stylesheet" href="https://code.jquery.com/ui/1.12.1/themes/base/jquery-ui.css">
    <script src="https://code.jquery.com/jquery-1.12.4.js"></script>
    <script src="https://code.jquery.com/ui/1.12.1/jquery-ui.js"></script>
    <script>
        $(function () {
            $("#datepicker").datepicker();
        });
    </script>
}

<h1>Créer un sondage :</h1>
<hr>
<form asp-controller="Sondage" asp-action="Create" method="post" id="myForm">
    <div asp-validation-summary="ModelOnly" class="text-danger"></div>

    <div class="d-md-block" id="questionDiv">
        <label asp-for="question" class="control-label"></label>  
        <input asp-for="question" class="form-control" type="text" id="question" name="question" placeholder="Entrez votre question..."/>
        <span asp-validation-for="question" class="text-danger"></span>
    </div>
    <div id="multi-choice-div">
        <label asp-for="isMultipleAnswer" class="control-label"></label>
        <input asp-for="isMultipleAnswer" id="isMultipleAnswer" name="isMultipleAnswer" value="false" class="colored-checkbox" onchange="this.value=this.checked"/>
    </div>

    <hr class="form-breaker">

    <div class="d-md-block" id="answerDiv">
        <label asp-for="answer" class="control-label">Réponses</label>
        <div class="answer-input-div">
            <a class="close-button">
                <i class="fas fa-check" aria-hidden="true"></i>
            </a>
            <input asp-for="answer" type="text" draggable="true" class="form-control answerInput" name="answer" placeholder="Entrez une réponse" required/>
        </div>
        <div class="answer-input-div">
            <a class="close-button">
                <i class="fas fa-check" aria-hidden="true"></i>
            </a>
            <input asp-for="answer" type="text" draggable="true" class="form-control answerInput" name="answer" placeholder="Entrez une réponse" required/>
        </div>
    </div>
    <input type="button"  class="btn colored-buttons" onclick="AddInput()" value="Ajouter une réponse"/>
    <br />
    <div class="modif-div" id="expirationDateLabel">
      <label asp-for="expirationDate" class="control-label"></label>
      <input asp-for="expirationDate" id="expirationDate" name="expirationDate" class="form-control" value="@DateTime.Now.ToString("yyyy-MM-ddThh:mm")" hidden="true"/>
      <span asp-validation-for="expirationDate" class="text-danger"></span>
    </div>
    <div class="modif-div">
      <label asp-for="expireWithDate" class="control-label"></label>
      <input class="colored-checkbox" asp-for="expireWithDate" id="expireWithDate" name="expireWithDate" value="false" onchange="checkBoxChange()"/>
    </div>
    <div class="modif-div">
      <label asp-for="notifiedByMail" class="control-label"></label>
      <input class="colored-checkbox" asp-for="notifiedByMail" id="notifiedByMail" name="notifiedByMail" value="false" onchange="this.value=this.checked"/>
    </div>
    <input type="submit" class="btn colored-buttons" value="Créer le Formulaire"/>
</form>

<script type="text/javascript">
    // start at 2 answers because it's the minimum
    var answersNum = 2;

    function AddInput() {
        // count the total of answers
        answersNum++;

        // create receiving div for drag and drop, to contain input and close button
        var newStructure = document.createElement('div');
        newStructure.className = "answer-input-div";
        newStructure.id = 'answerDiv_'+answersNum;

        // create new input to answer the question
        var newInput = document.createElement('input');
        newInput.type = "text";
        newInput.name = "answer";
        newInput.draggable = "true";
        newInput.className = "form-control answerInput";
        newInput.placeholder = "Entrez une réponse"

        // create the close button and link to the remove function
        var closeButton = document.createElement('a');
        closeButton.className = "close-button";
        var closeButtonIcon = document.createElement('i');
        closeButtonIcon.className = "fas fa-times";
        closeButton.appendChild(closeButtonIcon);

        closeButton.addEventListener("click", () => { removeInput(newStructure.id);}, false);

        // add the newly made container to the answer div
        var monForm = document.getElementById("answerDiv");
        monForm.appendChild(newStructure);
        newStructure.appendChild(closeButton);
        newStructure.appendChild(newInput);
    };

    // remove the added answer container
    function removeInput(idElement) {
        answersNum--;
        var el = document.getElementById(idElement);
        console.log('removed ele: '+ idElement);
        el.remove();
    }

  checkBoxChange(); 
    function checkBoxChange() {
        var check = document.getElementById("expireWithDate");
        var inputDate = document.getElementById("expirationDate");
        var labelDate = document.getElementById("expirationDateLabel");

        check.value = check.checked;
        if(!check.checked)
        {
            inputDate.hidden = true;
            labelDate.hidden = true;
        }
        else{
            inputDate.hidden = false;
            labelDate.hidden = false;
        }
    }
</script>

@* TEST DRAG AND DROP NOT READY YET
<script type="text/javascript">

document.addEventListener('DOMContentLoaded', (event) => {

  var dragSrcEl = null;
  
  function handleDragStart(e) {
    this.style.opacity = '0.4';
    
    dragSrcEl = this;

    e.dataTransfer.effectAllowed = 'move';
    e.dataTransfer.setData('text/html', this.innerHTML);
  }

  function handleDragOver(e) {
    if (e.preventDefault) {
      e.preventDefault();
    }

    e.dataTransfer.dropEffect = 'move';
    
    return false;
  }

  function handleDragEnter(e) {
    this.classList.add('over');
  }

  function handleDragLeave(e) {
    this.classList.remove('over');
  }

  function handleDrop(e) {
    if (e.stopPropagation) {
      e.stopPropagation(); // stops the browser from redirecting.
    }
    
    if (dragSrcEl != this) {
      dragSrcEl.innerHTML = this.innerHTML;
      this.innerHTML = e.dataTransfer.getData('text');
    }
    
    return false;
  }

  function handleDragEnd(e) {
    this.style.opacity = '1';
    
    items.forEach(function (item) {
      item.classList.remove('over');
    });
  }
  
  
  let items = document.querySelectorAll('.answer-input-div .answerInput');
  items.forEach(function(item) {
    item.addEventListener('dragstart', handleDragStart, false);
    item.addEventListener('dragenter', handleDragEnter, false);
    item.addEventListener('dragover', handleDragOver, false);
    item.addEventListener('dragleave', handleDragLeave, false);
    item.addEventListener('drop', handleDrop, false);
    item.addEventListener('dragend', handleDragEnd, false);
  });
});
</script> *@
